/*	**************************************************************************************
    *									overlay.js
    *									==========
    *
    *	Author:	Geva Zeichner
	*	Forum:	http://forums.mozillazine.org/viewtopic.php?t=408043
    *	Date:	15/04/2006
    *	Edited:	12/08/2006
    **************************************************************************************/

window.addEventListener("load", function(e){IMDb_Preview.handle_load(e);}, false);

var IMDb_Preview =
{
/*****************************************************************************************
 *	Handle_Load(e)
 *	==============
 *	Listeners, defs, inits...
 *****************************************************************************************/
handle_load: function(e)
{
	// Shhh... listen...
	window.addEventListener("unload", function(e){IMDb_Preview.handle_unload(e);}, false);
	window.addEventListener("mouseover", function(e){IMDb_Preview.handle_mouse_over(e);}, false);
	window.addEventListener("mousemove", function(e){IMDb_Preview.handle_mouse_move(e);}, false);
	//window.addEventListener("mouseup", function(e){IMDb_Preview.handle_mouse_click(e);}, false);
	
	// Consts
	this.TITLE_REGEXP = /^((http:\/\/)(\w*\.)?((imdb\.com)(.*)(\/title\/tt\d{7})(\/)?))$/;
	this.ACTOR_REGEXP = /^((http:\/\/)(\w*\.)?((imdb\.com)(.*)(\/name\/nm\d{7})(\/)?))$/;
	this.IMG_REGEXP = /^((http:\/\/ia\.imdb\.com\/media)(.*\.)(jpg)?(gif)?(png)?)$/;
	this.MOVIE_TYPE = 1;
	this.ACTOR_TYPE = 2;
	this.NOT_SUBMITTED_IMG_PATH = "chrome://imdb_preview/skin/not_submitted.png";
	this.LOADING_IMG_PATH = "chrome://imdb_preview/skin/loading.gif";
	this.LOADING_BG_PATH = "chrome://imdb_preview/skin/loading_bg.png";
	this.E404_IMG_PATH = "chrome://imdb_preview/skin/error_404.png";
	this.ERROR_IMG_PATH = "chrome://imdb_preview/skin/error.png";
	
	// Set variables
	this.prefs = Components.classes['@mozilla.org/preferences-service;1'].
					getService(Components.interfaces.nsIPrefService).
					getBranch('extensions.imdb_preview.');
	this.move_timer = "";
	this.terminate_timer = "";
	this.terminate_timer_on = false;
	this.mouse_over_url_target = "";
	this.loaded_url = "";
	this.last_url = " ";
	this.last_owner_doc = "";
	this.http_req = new XMLHttpRequest();
	this.is_showing = false;
	this.lock_processing = false;
	this.page_x = 0;
	this.page_y = 0;
	
	this.check_timer = "";
	
	this.loading_start_time = 0;
	this.complete_loading_time = 0;
	
	// Init preview settings //
	
	// Create preview divs
	this.preview_div = window._content.document.createElement("div");
	this.text_div = window._content.document.createElement("div");
	
	this.title_div = window._content.document.createElement("div");
	this.director_div = window._content.document.createElement("div");
	this.writer_div = window._content.document.createElement("div");
	this.poster_div = window._content.document.createElement("div");
	this.genere_div = window._content.document.createElement("div");
	this.plot_div = window._content.document.createElement("div");
	this.rating_div = window._content.document.createElement("div");
	this.cast_div = window._content.document.createElement("div");
	this.runtime_div = window._content.document.createElement("div");
	this.country_div = window._content.document.createElement("div");
	this.language_div = window._content.document.createElement("div");
	this.awards_div = window._content.document.createElement("div");
	this.recommend_div = window._content.document.createElement("div");
	
	this.birthdate_div = window._content.document.createElement("div");
	this.minibio_div = window._content.document.createElement("div");
	
	// Mark as our own stuff
	this.preview_div.setAttribute("imdb_preview", "true");
	this.text_div.setAttribute("imdb_preview", "true");
	
	this.title_div.setAttribute("imdb_preview", "true");
	this.director_div.setAttribute("imdb_preview", "true");
	this.writer_div.setAttribute("imdb_preview", "true");
	this.poster_div.setAttribute("imdb_preview", "true");
	this.genere_div.setAttribute("imdb_preview", "true");
	this.plot_div.setAttribute("imdb_preview", "true");
	this.rating_div.setAttribute("imdb_preview", "true");
	this.cast_div.setAttribute("imdb_preview", "true");
	this.runtime_div.setAttribute("imdb_preview", "true");
	this.country_div.setAttribute("imdb_preview", "true");
	this.language_div.setAttribute("imdb_preview", "true");
	this.awards_div.setAttribute("imdb_preview", "true");
	this.recommend_div.setAttribute("imdb_preview", "true");
	
	this.birthdate_div.setAttribute("imdb_preview", "true");
	this.minibio_div.setAttribute("imdb_preview", "true");
	
	// Append divs
	this.preview_div.appendChild(this.poster_div);
	this.preview_div.appendChild(this.text_div);
	
	this.text_div.appendChild(this.title_div);
	this.text_div.appendChild(this.rating_div);
	this.text_div.appendChild(this.cast_div);
	this.text_div.appendChild(this.plot_div);
	
	this.text_div.appendChild(this.birthdate_div);
	this.text_div.appendChild(this.minibio_div);
},

/*****************************************************************************************
 *	Handle_Unload()
 *	===============
 *	Cleanups...
 *****************************************************************************************/
handle_unload: function()
{
	if (this.prefs.prefHasUserValue("actual_loading_time"))
	{
		this.prefs.clearUserPref("actual_loading_time");
		this.prefs.clearUserPref("complete_loading_time");
		this.prefs.clearUserPref("poster_loading_time");
	}
	
	// used until v0.3
	if (this.prefs.prefHasUserValue("start_check"))
		this.prefs.clearUserPref("start_check");
	
	if (this.prefs.prefHasUserValue("stop_check"))
		this.prefs.clearUserPref("stop_check");
	
	if (this.prefs.prefHasUserValue("poster_timeout"))
		this.prefs.clearUserPref("poster_timeout");
	
	// used until v0.2.1
	if (this.prefs.prefHasUserValue("halt_time"))
		this.prefs.clearUserPref("halt_time");
},

/*****************************************************************************************
 *	Handle_Mouse_Down(e)
 *	====================
 *	
 *****************************************************************************************/
handle_mouse_click: function(e)
{	
	if (e.target.hasAttribute("href"))
	{
		this.terminate_preview();
	}
},

/*****************************************************************************************
 *	Handle_Mouse_Over(e)
 *	====================
 *	Gets info about what we stepped into
 *****************************************************************************************/
handle_mouse_over: function(e)
{
	this.page_x = e.pageX;
	this.page_y = e.pageY;
	this.mouse_over_url_target = unescape(e.target.href);
	this.last_owner_doc = e.originalTarget.ownerDocument;
	
	// If not related to us
	if (e.target.parentNode.nodeName != "#document")
	{
		if ((e.target.getAttribute("imdb_preview") != "true") &&
			(e.target.parentNode.getAttribute("imdb_preview") != "true") &&
			(this.mouse_over_url_target != this.loaded_url))
		{
			// Terminate preview
			if (!this.terminate_timer_on)
			{
				this.terminate_timer = setTimeout(
					function()
					{
						IMDb_Preview.terminate_preview();
						IMDb_Preview.terminate_timer_on = false;
						IMDb_Preview.dump("\nTERMINATING\n");
					}, this.prefs.getIntPref("hide_delay_time"));
				this.terminate_timer_on = true;
				this.dump("\nTERMINATE\n");
			}
		}
		else
		{
			if (this.terminate_timer_on)
			{
				clearTimeout(this.terminate_timer);
				this.terminate_timer_on = false;
				this.dump("\nDON'T TERMINATE\n");
			}
		}
	}
},

/*****************************************************************************************
 *	Handle_Mouse_Move(e)
 *	====================
 *	Checks if we are halting somewhere
 *****************************************************************************************/
handle_mouse_move: function(e)
{
	// Clear timer
	clearTimeout(this.move_timer);
	
	var movie_delay = this.prefs.getIntPref("movie_delay_time");
	var actor_delay = this.prefs.getIntPref("actor_delay_time");
	
	// If it's a movie link
	if ((this.mouse_over_url_target.match(this.TITLE_REGEXP)) &&
		(movie_delay >= 0) &&
		(e.target.parentNode.getAttribute("imdb_preview") != "true"))
		
		// Start timer
		this.move_timer = setTimeout(function(){IMDb_Preview.handle_mouse_halt();},
									 movie_delay);
	
	// If it's an actor link
	else if ((this.mouse_over_url_target.match(this.ACTOR_REGEXP)) &&
			 (actor_delay >= 0) &&
			 (e.target.parentNode.getAttribute("imdb_preview") != "true"))
		this.move_timer = setTimeout(function(){IMDb_Preview.handle_mouse_halt();},
									 actor_delay);
},

/*****************************************************************************************
 *	Handle_Mouse_Halt()
 *	===================
 *	Checks if we halted on the right spot
 *****************************************************************************************/
handle_mouse_halt: function()
{
	// If standing on url that is different from the one stood on before
	if (this.mouse_over_url_target != this.last_url)
	{
		// If it's a movie link
		if (this.mouse_over_url_target.match(this.TITLE_REGEXP))
		{
			// Load url
			this.load_target(this.mouse_over_url_target, this.MOVIE_TYPE);
			this.loaded_url = this.mouse_over_url_target;
		}
		
		// If it's an actor link
		else if (this.mouse_over_url_target.match(this.ACTOR_REGEXP))
		{
			// Load url
			this.load_target(this.mouse_over_url_target, this.ACTOR_TYPE);
		}
	}
	this.last_url = this.mouse_over_url_target;
},

/*****************************************************************************************
 *	Load_Target(url_target, target_type)
 *	====================================
 *	Retrives the target's html code and triggers its processing
 *****************************************************************************************/
load_target: function(url_target, target_type)
{
	clearTimeout(this.terminate_timer);
	this.terminate_timer_on = false;
	this.terminate_preview();
	
	this.is_showing = true;
	this.dump("\nLoading...\n");
	
	this.complete_loading_time = 0;
	this.loading_start_time = new Date();
	
	// Start showing preview box
	this.Start_Preview();
	
	// Load target
	this.http_req.open('GET', url_target, true);
	
	// Try to process before loading completed
	this.check_timer =
		window.setInterval(
		function()
		{
			// Process
			IMDb_Preview.process_response(IMDb_Preview.http_req.responseText,
										  target_type);
		},
		IMDb_Preview.prefs.getIntPref("check_intervals"));
	
	// When finished loading
	this.http_req.onreadystatechange =
	function()
	{
		// If loading completed
		if (IMDb_Preview.http_req.readyState == 4)
		IMDb_Preview.timer = setTimeout(
		function ()
		{
			// Stop check html
			window.clearInterval(IMDb_Preview.check_timer);
			
			try
			{
				// With no error
				if (IMDb_Preview.http_req.status == 200)
				{
					var curr_date = new Date();
					
					// Process
					IMDb_Preview.process_response(IMDb_Preview.http_req.responseText,
												  target_type);
					
					IMDb_Preview.complete_loading_time =
						curr_date - IMDb_Preview.loading_start_time;
					IMDb_Preview.dump("complete: " +
									  IMDb_Preview.complete_loading_time + " ms\n");
					IMDb_Preview.prefs.setIntPref("complete_loading_time",
												  IMDb_Preview.complete_loading_time);
				}
				else
				{
					var curr_date = new Date();
					IMDb_Preview.loading_end_time = curr_date;
					IMDb_Preview.dump("Error loading page\n");
				}
			}
			catch(err)
			{
				IMDb_Preview.dump(err);
			}
		}, 0);
	};
	this.http_req.send(null);
},

/*****************************************************************************************
 *	Start_Preview()
 *	===============
 *****************************************************************************************/
Start_Preview: function()
{
	var doc = window._content.document;
	var top, left;
	var height = this.prefs.getIntPref("text_height");
	var poster_width = 100;
	var text_width = this.prefs.getIntPref("text_width");
	var padding = 5;
	var total_height = padding + height + padding;
	var total_width = padding + poster_width + padding + text_width + padding;
	
	// If in upper half
	if (this.page_y < (doc.defaultView.innerHeight / 2) + doc.defaultView.pageYOffset)
		top = this.page_y + 5;
	else top = this.page_y - total_height - 5;
	
	// If in left half
	if (this.page_x < (doc.defaultView.innerWidth / 2) + doc.defaultView.pageXOffset)
		left = this.page_x + 5;
	else left = this.page_x - total_width - 5;
	
	// Position preview and set divs style
	this.preview_div.setAttribute("style", "position: absolute; \
											top: " + top + "px; \
											left: " + left + "px; \
											background-color: #FFFFCC; \
											padding: " + padding + " " + padding + " " +
														 0       + " " + padding + ";");
	
	this.poster_div.setAttribute("style", "float: left; \
										   padding: 0 " + padding + " 0 0; \
										   width: " + poster_width + "px; \
										   height: " + height + "px;");
	
	this.text_div.setAttribute("style", "overflow: auto; \
										 width: " + text_width + "px; \
										 height: " + height + "px;");
	
	// Show preview
	window._content.document.body.appendChild(this.preview_div);
},

/*****************************************************************************************
 *	Process_Response(html_source, target_type)
 *	==========================================
 *****************************************************************************************/
process_response: function(html_source, target_type)
{
	var movie = new Array(5);
	var actor = new Array(5);
	
	// If a movie page
	if (target_type == this.MOVIE_TYPE)
	{
		// Proccess movie
		this.process_movie_html(html_source, movie);
		
		// If found title
		if (movie['title'] != -1)
			this.title_div.innerHTML = "Title: " + movie['title'];
		
		// If found poster
		if (movie['poster'] != -1)
			this.poster_div.innerHTML = "<img src=\"" + movie['poster'] + "\">";
		
		// If found plot
		if (movie['plot'] != -1)
			this.plot_div.innerHTML = "Plot: " + movie['plot'];
		
		// If found rating
		if (movie['rating'] != -1)
			this.rating_div.innerHTML = "Rating: " + movie['rating'] + "/10";
		
		// If found cast
		if (movie['cast'] != -1)
			this.cast_div.innerHTML = "Cast: " + movie['cast'];
	}
	
	// If an actor page
	else if (target_type == this.ACTOR_TYPE)
	{
		// Proccess actor
		this.process_actor_html(html_source, actor);
		
		// If found title
		if (actor['title'] != -1)
			this.title_div.innerHTML = "Name: " + actor['title'];
		
		// If found poster
		if (actor['poster'] != -1)
			this.poster_div.innerHTML = "<img src=\"" + actor['poster'] + "\">";
		
		// If found birthdate
		if (actor['birthdate'] != -1)
			this.birthdate_div.innerHTML = "Birthdate: " + actor['birthdate'];
		
		// If found location
		if (actor['location'] != -1)
			this.birthdate_div.innerHTML += " (" + actor['location'] + ")";
		
		// If found minibio
		if (actor['minibio'] != -1)
			this.minibio_div.innerHTML = "Minibio: " + actor['minibio'];
	}
},

/*****************************************************************************************
 *	Process_Movie_HTML(html_source, movie)
 *	======================================
 *****************************************************************************************/
process_movie_html: function(html_source, movie)
{
	movie['title']	= -1;
	movie['poster']	= -1;
	movie['plot']	= -1;
	movie['rating']	= -1;
	movie['cast']	= -1;
	
	// Title
	movie['title'] = this.retrieve_string(html_source, '<title>', '<title>', '</title>');
	
	// Poster
	movie['poster'] = this.retrieve_string(html_source, '<a name="poster"', 'src="', '" height');
	if (movie['poster'] == -1)
	{
		// Maybe poster not submitted
		if (html_source.indexOf('title="Poster Not Submitted"') != -1)
			movie['poster'] = "http://ia.imdb.com/media/imdb/01/I/44/47/29.gif";
	}
	
	// Plot
	movie['plot'] = this.retrieve_string(html_source,
							  '<b class="ch">Plot Outline:</b>', '</b> ', '<br><br>');
	
	// Rating
	movie['rating'] = this.retrieve_string(html_source,
							  '<b class="ch">User Rating:</b>', '<b>', '/10</b>');
	
	// Cast
	movie['cast'] = this.retrieve_string(html_source,
							  'Cast overview', '<td valign="middle">', '</td>');
},

/*****************************************************************************************
 *	Process_Actor_HTML (html_source, actor)
 *	=======================================
 *****************************************************************************************/
process_actor_html: function(html_source, actor)
{
	actor['title']		= -1;
	actor['poster']		= -1;
	actor['birthdate']	= -1;
	actor['location']	= -1;
	actor['minibio']	= -1;
	
	// Title
	actor['title'] = this.retrieve_string(html_source,
						'<title>', '<title>', '</title>');
	
	// Poster
	actor['poster'] = this.retrieve_string(html_source,
						'<a name="headshot"', 'src="', '" width');
	if (actor['poster'] == -1)
	{
		// Maybe poster not submitted
		if (html_source.indexOf('alt="Photo Not Submitted"') != -1)
			actor['poster'] = "http://ia.imdb.com/media/imdb/01/I/24/27/20/10.gif";
	}
	
	// Birthdate
	actor['birthdate'] = this.retrieve_string(html_source,
						'Date of birth', '<dd>', '<br>');
	
	// Location of birth
	actor['location'] = this.retrieve_string(html_source,
						'Date of birth', '<br>', '</dd>');
	
	// Mini biography
	actor['minibio'] = this.retrieve_string(html_source,
						'Mini biography', '<dd>', '</dd>');
},

/*****************************************************************************************
 *	Retrieve_String (Source, Unique, Pre, Post)
 *	===========================================
 *	Retrieves the string that is in between specified values. Returns -1 if failed.
 *	Source: String to look in.
 *	Unique: Unique string to identify the area of the wanted string.
 *	Pre: The string that comes right before the wanted string.
 *	Post: The string that comes right after the wanted string.
 *****************************************************************************************/
retrieve_string: function(source, unique, pre, post)
{
	var unique_pos, start_pos, end_pos;
	var found_string = -1;
	
	unique_pos = source.indexOf(unique);
	if (unique_pos != -1)
	{
		start_pos = source.indexOf(pre, unique_pos) + pre.length;
		if (start_pos != -1)
		{
			end_pos = source.indexOf(post, start_pos);
			if (end_pos != -1)
			{
				found_string = source.substring(start_pos, end_pos);
			}
		}
	}
	
	return(found_string);
},

/*****************************************************************************************
 *	Terminate_Preview()
 *	===================
 *	I'll be back...
 *****************************************************************************************/
terminate_preview: function()
{
	if (this.is_showing == true)
	{
		window.clearInterval(this.check_timer);
		this.is_showing = false;
		window._content.document.body.appendChild(this.preview_div);
		window._content.document.body.removeChild(this.preview_div);
		this.last_url = " ";
		this.loaded_url = "";
		this.http_req.abort();
		
		// Clear information
		this.title_div.innerHTML = "";
		this.poster_div.innerHTML = "";
		this.plot_div.innerHTML = "";
		this.rating_div.innerHTML = "";
		this.cast_div.innerHTML = "";
		this.birthdate_div.innerHTML = "";
		this.minibio_div.innerHTML = "";
	}
},

/*****************************************************************************************
 *	Dump(text)
 *	==========
 *****************************************************************************************/
dump: function(text)
{
	if (this.prefs.getBoolPref("dump") == true)
	{
		dump(text);
	}
}
};